Package weka.gui

# Class PropertySheetPanel

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
weka.gui.PropertySheetPanel

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `PropertyChangeListener`, `Serializable`, `EventListener`, `Accessible`, `EnvironmentHandler`

public class PropertySheetPanel extends JPanel implements PropertyChangeListener, EnvironmentHandler
Displays a property sheet where (supported) properties of the target object may be edited.

Version:
  $Revision: 15453 $
Author:
  Len Trigg (trigg@cs.waikato.ac.nz)
See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class javax.swing.JComponent

  `JComponent.AccessibleJComponent`

  ## Nested classes/interfaces inherited from class java.awt.Component

  `Component.BaselineResizeBehavior`

- ## Field Summary

  ### Fields inherited from class javax.swing.JComponent

  `TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

  ### Fields inherited from class java.awt.Component

  `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

  ### Fields inherited from interface java.awt.image.ImageObserver

  `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PropertySheetPanel()`
  Creates the property sheet panel with an about panel.
  `PropertySheetPanel(boolean showAboutPanel)`
  Creates the property sheet panel

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addPropertyChangeListener(PropertyChangeListener l)`
  Adds a PropertyChangeListener.
  `void`
  `closingCancel()`
  Pass on a CANCEL closing notificiation to the customizer (if one is in use).
  `void`
  `closingOK()`
  Pass on an OK closing notification to the customizer (if one is in use)
  `int`
  `editableProperties()`
  Gets the number of editable properties for the current target.
  `JPanel`
  `getAboutPanel()`
  Return the panel containing global info and help for the object being edited.
  `String`
  `getPropertyGroupingCategory()`
  `boolean`
  `getUseEnvironmentPropertyEditors()`
  Get whether to use environment property editors for string and file properties
  `boolean`
  `hasCustomizer()`
  Returns true if the object being edited has a customizer
  `void`
  `propertyChange(PropertyChangeEvent evt)`
  Updates the property sheet panel with a changed property and also passed the event along.
  `void`
  `removePropertyChangeListener(PropertyChangeListener l)`
  Removes a PropertyChangeListener.
  `void`
  `setEnvironment(Environment env)`
  Set environment variables to pass on to any editor that can use them
  `void`
  `setPropertyGroupingCategory(String category)`
  `void`
  `setTarget(Object targ)`
  Sets a new target object for customisation.
  `void`
  `setUseEnvironmentPropertyEditors(boolean u)`
  Set whether to use environment property editors for string and file properties

  ### Methods inherited from class javax.swing.JPanel

  `getAccessibleContext, getUI, getUIClassID, setUI, updateUI`

  ### Methods inherited from class javax.swing.JComponent

  `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

  ### Methods inherited from class java.awt.Container

  `add, add, add, add, add, addContainerListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate`

  ### Methods inherited from class java.awt.Component

  `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, createImage, createImage, createVolatileImage, createVolatileImage, dispatchEvent, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### PropertySheetPanel

    public PropertySheetPanel()
    Creates the property sheet panel with an about panel.

  - ### PropertySheetPanel

    public PropertySheetPanel(boolean showAboutPanel)
    Creates the property sheet panel
    Parameters:
      `showAboutPanel` - true if the about panel is to be shown

- ## Method Details

  - ### setUseEnvironmentPropertyEditors

    public void setUseEnvironmentPropertyEditors(boolean u)
    Set whether to use environment property editors for string and file properties
    Parameters:
      `u` - true to use environment property editors

  - ### getUseEnvironmentPropertyEditors

    public boolean getUseEnvironmentPropertyEditors()
    Get whether to use environment property editors for string and file properties
    Returns:
      true to use environment property editors

  - ### setPropertyGroupingCategory

    public void setPropertyGroupingCategory(String category)

  - ### getPropertyGroupingCategory

    public String getPropertyGroupingCategory()

  - ### getAboutPanel

    public JPanel getAboutPanel()
    Return the panel containing global info and help for the object being edited. May return null if the edited object provides no global info or tip text.
    Returns:
      the about panel.

  - ### propertyChange

    public void propertyChange(PropertyChangeEvent evt)
    Updates the property sheet panel with a changed property and also passed the event along.
    Specified by:
      `propertyChange` in interface `PropertyChangeListener`
    Parameters:
      `evt` - a value of type 'PropertyChangeEvent'

  - ### addPropertyChangeListener

    public void addPropertyChangeListener(PropertyChangeListener l)
    Adds a PropertyChangeListener.
    Overrides:
      `addPropertyChangeListener` in class `Container`
    Parameters:
      `l` - a value of type 'PropertyChangeListener'

  - ### removePropertyChangeListener

    public void removePropertyChangeListener(PropertyChangeListener l)
    Removes a PropertyChangeListener.
    Overrides:
      `removePropertyChangeListener` in class `Component`
    Parameters:
      `l` - a value of type 'PropertyChangeListener'

  - ### setTarget

    public void setTarget(Object targ)
    Sets a new target object for customisation.
    Parameters:
      `targ` - a value of type 'Object'

  - ### editableProperties

    public int editableProperties()
    Gets the number of editable properties for the current target.
    Returns:
      the number of editable properties.

  - ### hasCustomizer

    public boolean hasCustomizer()
    Returns true if the object being edited has a customizer
    Returns:
      true if the object being edited has a customizer

  - ### setEnvironment

    public void setEnvironment(Environment env)
    Set environment variables to pass on to any editor that can use them
    Specified by:
      `setEnvironment` in interface `EnvironmentHandler`
    Parameters:
      `env` - the variables to pass on to individual property editors

  - ### closingOK

    public void closingOK()
    Pass on an OK closing notification to the customizer (if one is in use)

  - ### closingCancel

    public void closingCancel()
    Pass on a CANCEL closing notificiation to the customizer (if one is in use).